/*
* SPDX-License-Identifier: GPL
*
* Copyright (c) 2020 ChangSha JingJiaMicro Electronics Co., Ltd.
* All rights reserved.
*
* Author:
*      shanjinkui <shanjinkui@jingjiamicro.com>
*
* The software and information contained herein is proprietary and
* confidential to JingJiaMicro Electronics. This software can only be
* used by JingJiaMicro Electronics Corporation. Any use, reproduction,
* or disclosure without the written permission of JingJiaMicro
* Electronics Corporation is strictly prohibited.
*/
#include "mwv207_sched.h"

#define MAX(a, b) ((a) > (b) ? (a) : (b))

struct pipe_codec_wb_entry {
	u64 vram;
	u32 reg;
	u32 nr;
};

struct pipe_codec_sw_pp {
	struct pipe_codec_wb_entry wb[0x10];
	u32  wb_buf[MAX(0x1F4,0x1F7)];
	int  wb_cnt;
	bool pending;
};

void pipe_codec_sw_pp_reset(struct pipe_codec_sw_pp *sw_pp);
void pipe_codec_sw_pp_excute(struct pipe_codec_sw_pp *sw_pp, struct mwv207_pipe *pipe);
void pipe_codec_sw_pp_submit(struct pipe_codec_sw_pp *sw_pp, struct mwv207_pipe *pipe,
		struct mwv207_job *mjob, int pos, int *cmdlen);

